<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::afml::FocusManager Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1afml.html">afml</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_focus_manager.html">FocusManager</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1afml_1_1_focus_manager-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::afml::FocusManager Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_focus_manager_8h_source.html">FocusManager.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::afml::FocusManager:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1afml_1_1_focus_manager__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1afml_1_1_focus_manager_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1afml_1_1_focus_manager_inherit__map" id="alexa_client_s_d_k_1_1afml_1_1_focus_manager_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::FocusManagerInterface" alt="" coords="5,5,262,44"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<div class="dynheader">
Collaboration diagram for alexaClientSDK::afml::FocusManager:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1afml_1_1_focus_manager__coll__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1afml_1_1_focus_manager_coll__map" alt="Collaboration graph"/></div>
<map name="alexa_client_s_d_k_1_1afml_1_1_focus_manager_coll__map" id="alexa_client_s_d_k_1_1afml_1_1_focus_manager_coll__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::FocusManagerInterface" alt="" coords="5,5,262,44"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structalexa_client_s_d_k_1_1afml_1_1_focus_manager_1_1_channel_configuration.html">ChannelConfiguration</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ad5a9b9e4482fab1c48a7b156d8a3be0d"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_focus_manager.html#ad5a9b9e4482fab1c48a7b156d8a3be0d">FocusManager</a> (const std::vector&lt; <a class="el" href="structalexa_client_s_d_k_1_1afml_1_1_focus_manager_1_1_channel_configuration.html">ChannelConfiguration</a> &gt; channelConfigurations, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_activity_tracker_interface.html">ActivityTrackerInterface</a> &gt; activityTrackerInterface=nullptr)</td></tr>
<tr class="separator:ad5a9b9e4482fab1c48a7b156d8a3be0d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6d0a1f73862379e0f3e77703228352e4"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_focus_manager.html#a6d0a1f73862379e0f3e77703228352e4">acquireChannel</a> (const std::string &amp;channelName, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_channel_observer_interface.html">avsCommon::sdkInterfaces::ChannelObserverInterface</a> &gt; channelObserver, const std::string &amp;interface) override</td></tr>
<tr class="separator:a6d0a1f73862379e0f3e77703228352e4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2070cf2dd51b99215429327d393d49c5"><td class="memItemLeft" align="right" valign="top">std::future&lt; bool &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_focus_manager.html#a2070cf2dd51b99215429327d393d49c5">releaseChannel</a> (const std::string &amp;channelName, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_channel_observer_interface.html">avsCommon::sdkInterfaces::ChannelObserverInterface</a> &gt; channelObserver) override</td></tr>
<tr class="separator:a2070cf2dd51b99215429327d393d49c5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a74d546bdcca778681aba6b9194279bc7"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_focus_manager.html#a74d546bdcca778681aba6b9194279bc7">stopForegroundActivity</a> () override</td></tr>
<tr class="separator:a74d546bdcca778681aba6b9194279bc7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae72baa5213e17c7efb150d62d2d27ac4"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_focus_manager.html#ae72baa5213e17c7efb150d62d2d27ac4">stopAllActivities</a> () override</td></tr>
<tr class="separator:ae72baa5213e17c7efb150d62d2d27ac4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae4d4580bdf4aac64f50c79c35919a7ad"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_focus_manager.html#ae4d4580bdf4aac64f50c79c35919a7ad">addObserver</a> (const std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_observer_interface.html">avsCommon::sdkInterfaces::FocusManagerObserverInterface</a> &gt; &amp;observer) override</td></tr>
<tr class="separator:ae4d4580bdf4aac64f50c79c35919a7ad"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0dfc2a219f6541918feb41baeb074e0b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_focus_manager.html#a0dfc2a219f6541918feb41baeb074e0b">removeObserver</a> (const std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_observer_interface.html">avsCommon::sdkInterfaces::FocusManagerObserverInterface</a> &gt; &amp;observer) override</td></tr>
<tr class="separator:a0dfc2a219f6541918feb41baeb074e0b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::FocusManagerInterface</a></td></tr>
<tr class="memitem:a02a609d44d349193d726d9e35704660b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html#a02a609d44d349193d726d9e35704660b">~FocusManagerInterface</a> ()=default</td></tr>
<tr class="memdesc:a02a609d44d349193d726d9e35704660b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html#a02a609d44d349193d726d9e35704660b">More...</a><br /></td></tr>
<tr class="separator:a02a609d44d349193d726d9e35704660b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:a6ac101376dff28e543f153b985ae6a0d"><td class="memItemLeft" align="right" valign="top">static const std::vector&lt; <a class="el" href="structalexa_client_s_d_k_1_1afml_1_1_focus_manager_1_1_channel_configuration.html">FocusManager::ChannelConfiguration</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_focus_manager.html#a6ac101376dff28e543f153b985ae6a0d">getDefaultAudioChannels</a> ()</td></tr>
<tr class="separator:a6ac101376dff28e543f153b985ae6a0d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae51ca0607eefae514952661d752a5d51"><td class="memItemLeft" align="right" valign="top">static const std::vector&lt; <a class="el" href="structalexa_client_s_d_k_1_1afml_1_1_focus_manager_1_1_channel_configuration.html">FocusManager::ChannelConfiguration</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_focus_manager.html#ae51ca0607eefae514952661d752a5d51">getDefaultVisualChannels</a> ()</td></tr>
<tr class="separator:ae51ca0607eefae514952661d752a5d51"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface')"><img src="closed.png" alt="-"/>&#160;Static Public Attributes inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::FocusManagerInterface</a></td></tr>
<tr class="memitem:ad394dd6b26126ab84a82a1ef864f8ddf inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="memItemLeft" align="right" valign="top">static constexpr const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html#ad394dd6b26126ab84a82a1ef864f8ddf">DIALOG_CHANNEL_NAME</a> = &quot;Dialog&quot;</td></tr>
<tr class="memdesc:ad394dd6b26126ab84a82a1ef864f8ddf inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">The default Dialog Channel name.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html#ad394dd6b26126ab84a82a1ef864f8ddf">More...</a><br /></td></tr>
<tr class="separator:ad394dd6b26126ab84a82a1ef864f8ddf inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a645398e7765774df256d3b8240b3b245 inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="memItemLeft" align="right" valign="top">static constexpr unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html#a645398e7765774df256d3b8240b3b245">DIALOG_CHANNEL_PRIORITY</a> = 100</td></tr>
<tr class="memdesc:a645398e7765774df256d3b8240b3b245 inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">The default dialog Channel priority.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html#a645398e7765774df256d3b8240b3b245">More...</a><br /></td></tr>
<tr class="separator:a645398e7765774df256d3b8240b3b245 inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae56fda300bb2eb0260fc31a85c151277 inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="memItemLeft" align="right" valign="top">static constexpr const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html#ae56fda300bb2eb0260fc31a85c151277">COMMUNICATIONS_CHANNEL_NAME</a> = &quot;Communications&quot;</td></tr>
<tr class="memdesc:ae56fda300bb2eb0260fc31a85c151277 inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">The default Communications Channel name.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html#ae56fda300bb2eb0260fc31a85c151277">More...</a><br /></td></tr>
<tr class="separator:ae56fda300bb2eb0260fc31a85c151277 inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0e42c92d519c55340d05d875ff30fbfb inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="memItemLeft" align="right" valign="top">static constexpr unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html#a0e42c92d519c55340d05d875ff30fbfb">COMMUNICATIONS_CHANNEL_PRIORITY</a> = 150</td></tr>
<tr class="memdesc:a0e42c92d519c55340d05d875ff30fbfb inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">The default Communications Channel priority.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html#a0e42c92d519c55340d05d875ff30fbfb">More...</a><br /></td></tr>
<tr class="separator:a0e42c92d519c55340d05d875ff30fbfb inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2ee65065d0810098cab8d52b06335104 inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="memItemLeft" align="right" valign="top">static constexpr const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html#a2ee65065d0810098cab8d52b06335104">ALERT_CHANNEL_NAME</a> = &quot;Alert&quot;</td></tr>
<tr class="memdesc:a2ee65065d0810098cab8d52b06335104 inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">The default Alert Channel name.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html#a2ee65065d0810098cab8d52b06335104">More...</a><br /></td></tr>
<tr class="separator:a2ee65065d0810098cab8d52b06335104 inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae74caa3e3eee3728216cc95462c07d9c inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="memItemLeft" align="right" valign="top">static constexpr unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html#ae74caa3e3eee3728216cc95462c07d9c">ALERT_CHANNEL_PRIORITY</a> = 200</td></tr>
<tr class="memdesc:ae74caa3e3eee3728216cc95462c07d9c inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">The default Alert Channel priority.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html#ae74caa3e3eee3728216cc95462c07d9c">More...</a><br /></td></tr>
<tr class="separator:ae74caa3e3eee3728216cc95462c07d9c inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a665ff812ec1ce4cdc68ae409673ad0be inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="memItemLeft" align="right" valign="top">static constexpr const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html#a665ff812ec1ce4cdc68ae409673ad0be">CONTENT_CHANNEL_NAME</a> = &quot;Content&quot;</td></tr>
<tr class="memdesc:a665ff812ec1ce4cdc68ae409673ad0be inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">The default Content Channel name.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html#a665ff812ec1ce4cdc68ae409673ad0be">More...</a><br /></td></tr>
<tr class="separator:a665ff812ec1ce4cdc68ae409673ad0be inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a63c396d5a7adaa78db5eccf9cb11224b inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="memItemLeft" align="right" valign="top">static constexpr unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html#a63c396d5a7adaa78db5eccf9cb11224b">CONTENT_CHANNEL_PRIORITY</a> = 300</td></tr>
<tr class="memdesc:a63c396d5a7adaa78db5eccf9cb11224b inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">The default Content Channel priority.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html#a63c396d5a7adaa78db5eccf9cb11224b">More...</a><br /></td></tr>
<tr class="separator:a63c396d5a7adaa78db5eccf9cb11224b inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3a09118eba4f058027dcd43245ec6df0 inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="memItemLeft" align="right" valign="top">static constexpr const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html#a3a09118eba4f058027dcd43245ec6df0">VISUAL_CHANNEL_NAME</a> = &quot;Visual&quot;</td></tr>
<tr class="memdesc:a3a09118eba4f058027dcd43245ec6df0 inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">The default Visual Channel name.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html#a3a09118eba4f058027dcd43245ec6df0">More...</a><br /></td></tr>
<tr class="separator:a3a09118eba4f058027dcd43245ec6df0 inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6356456affc0965f1db94f04030ecf4b inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="memItemLeft" align="right" valign="top">static constexpr unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html#a6356456affc0965f1db94f04030ecf4b">VISUAL_CHANNEL_PRIORITY</a> = 100</td></tr>
<tr class="memdesc:a6356456affc0965f1db94f04030ecf4b inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">The default Visual Channel priority.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html#a6356456affc0965f1db94f04030ecf4b">More...</a><br /></td></tr>
<tr class="separator:a6356456affc0965f1db94f04030ecf4b inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">The <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_focus_manager.html">FocusManager</a> takes requests to acquire and release Channels and updates the focuses of other Channels based on their priorities so that the invariant that there can only be one Foreground <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_channel.html">Channel</a> is held. The following operations are provided:</p>
<p class="">acquire <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_channel.html">Channel</a> - clients should call the <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_focus_manager.html#a6d0a1f73862379e0f3e77703228352e4">acquireChannel()</a> method, passing in the name of the <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_channel.html">Channel</a> they wish to acquire, a pointer to the observer that they want to be notified once they get focus, and a unique interface name.</p>
<p class="">release <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_channel.html">Channel</a> - clients should call the <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_focus_manager.html#a2070cf2dd51b99215429327d393d49c5">releaseChannel()</a> method, passing in the name of the <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_channel.html">Channel</a> and the observer of the <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_channel.html">Channel</a> they wish to release.</p>
<p class="">stop foreground <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_channel.html">Channel</a> - clients should call the <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_focus_manager.html#a74d546bdcca778681aba6b9194279bc7">stopForegroundActivity()</a> method.</p>
<p class="">All of these methods will notify the observer of the <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_channel.html">Channel</a> of focus changes via an asynchronous callback to the ChannelObserverInterface##onFocusChanged() method, at which point the client should make a user observable change based on the focus it receives. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="ad5a9b9e4482fab1c48a7b156d8a3be0d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad5a9b9e4482fab1c48a7b156d8a3be0d">&#9670;&nbsp;</a></span>FocusManager()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::afml::FocusManager::FocusManager </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; <a class="el" href="structalexa_client_s_d_k_1_1afml_1_1_focus_manager_1_1_channel_configuration.html">ChannelConfiguration</a> &gt;&#160;</td>
          <td class="paramname"><em>channelConfigurations</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_activity_tracker_interface.html">ActivityTrackerInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>activityTrackerInterface</em> = <code>nullptr</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">This constructor creates Channels based on the provided configurations.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">channelConfigurations</td><td>A vector of <code>channelConfiguration</code> objects that will be used to create the Channels. No two Channels should have the same name or priority. If there are multiple configurations with the same name or priority, the latter Channels with that name or priority will not be created. </td></tr>
    <tr><td class="paramname">activityTrackerInterface</td><td>The interface to notify the activity tracker a vector of channel states that has been updated. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a6d0a1f73862379e0f3e77703228352e4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6d0a1f73862379e0f3e77703228352e4">&#9670;&nbsp;</a></span>acquireChannel()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::afml::FocusManager::acquireChannel </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>channelName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_channel_observer_interface.html">avsCommon::sdkInterfaces::ChannelObserverInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>channelObserver</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>interface</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">This method will acquire the channel and grant the appropriate focus to it and other channels if needed. The caller will be notified via an ChannelObserverInterface##onFocusChanged() call to the <code>channelObserver</code> when it can start the activity. If the <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_channel.html">Channel</a> was already held by a different observer, the observer will be notified via ChannelObserverInterface##onFocusChanged() to stop before letting the new observer start.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">channelName</td><td>The name of the <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_channel.html">Channel</a> to acquire. </td></tr>
    <tr><td class="paramname">channelObserver</td><td>The observer that will be acquiring the <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_channel.html">Channel</a> and be notified of focus changes. </td></tr>
    <tr><td class="paramname">interface</td><td>The name of the AVS interface occupying the <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_channel.html">Channel</a>. This should be unique and represents the name of the AVS interface using the <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_channel.html">Channel</a>. The name of the AVS interface is used by the ActivityTracker to send Context to AVS.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Returns <code>true</code> if the <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_channel.html">Channel</a> can be acquired and <code>false</code> otherwise. </dd></dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html#ab7cface67c4e4498a7bcc577c9c702b1">alexaClientSDK::avsCommon::sdkInterfaces::FocusManagerInterface</a>.</p>

</div>
</div>
<a id="ae4d4580bdf4aac64f50c79c35919a7ad"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae4d4580bdf4aac64f50c79c35919a7ad">&#9670;&nbsp;</a></span>addObserver()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::afml::FocusManager::addObserver </td>
          <td>(</td>
          <td class="paramtype">const std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_observer_interface.html">avsCommon::sdkInterfaces::FocusManagerObserverInterface</a> &gt; &amp;&#160;</td>
          <td class="paramname"><em>observer</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Add an observer to the focus manager.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">observer</td><td>The observer to add. </td></tr>
  </table>
  </dd>
</dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html#a2f17f293bfe792de29b7b75b131b8bf2">alexaClientSDK::avsCommon::sdkInterfaces::FocusManagerInterface</a>.</p>

</div>
</div>
<a id="a6ac101376dff28e543f153b985ae6a0d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6ac101376dff28e543f153b985ae6a0d">&#9670;&nbsp;</a></span>getDefaultAudioChannels()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const std::vector&lt; <a class="el" href="structalexa_client_s_d_k_1_1afml_1_1_focus_manager_1_1_channel_configuration.html">FocusManager::ChannelConfiguration</a> &gt; alexaClientSDK::afml::FocusManager::getDefaultAudioChannels </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Retrieves the default <code><a class="el" href="structalexa_client_s_d_k_1_1afml_1_1_focus_manager_1_1_channel_configuration.html">ChannelConfiguration</a></code> for AVS audio channels.</p>
<dl class="section return"><dt>Returns</dt><dd>the default <code><a class="el" href="structalexa_client_s_d_k_1_1afml_1_1_focus_manager_1_1_channel_configuration.html">ChannelConfiguration</a></code> for AVS audio channels. </dd></dl>

</div>
</div>
<a id="ae51ca0607eefae514952661d752a5d51"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae51ca0607eefae514952661d752a5d51">&#9670;&nbsp;</a></span>getDefaultVisualChannels()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const std::vector&lt; <a class="el" href="structalexa_client_s_d_k_1_1afml_1_1_focus_manager_1_1_channel_configuration.html">FocusManager::ChannelConfiguration</a> &gt; alexaClientSDK::afml::FocusManager::getDefaultVisualChannels </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Retrieves the default <code><a class="el" href="structalexa_client_s_d_k_1_1afml_1_1_focus_manager_1_1_channel_configuration.html">ChannelConfiguration</a></code> for AVS visual channels.</p>
<dl class="section return"><dt>Returns</dt><dd>the default <code><a class="el" href="structalexa_client_s_d_k_1_1afml_1_1_focus_manager_1_1_channel_configuration.html">ChannelConfiguration</a></code> for AVS visual channels. </dd></dl>

</div>
</div>
<a id="a2070cf2dd51b99215429327d393d49c5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2070cf2dd51b99215429327d393d49c5">&#9670;&nbsp;</a></span>releaseChannel()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::future&lt; bool &gt; alexaClientSDK::afml::FocusManager::releaseChannel </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>channelName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_channel_observer_interface.html">avsCommon::sdkInterfaces::ChannelObserverInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>channelObserver</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">This method will release the <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_channel.html">Channel</a> and notify the observer of the <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_channel.html">Channel</a>, if the observer is the same as the observer passed in the acquireChannel call, to stop via ChannelObserverInterface##onFocusChanged(). If the <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_channel.html">Channel</a> to release is the current foreground focused <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_channel.html">Channel</a>, it will also notify the next highest priority <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_channel.html">Channel</a> via an ChannelObserverInterface##onFocusChanged() callback that it has gained foreground focus.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">channelName</td><td>The name of the <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_channel.html">Channel</a> to release. </td></tr>
    <tr><td class="paramname">channelObserver</td><td>The observer to be released from the <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_channel.html">Channel</a>. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd><code>std::future&lt;bool&gt;</code> which will contain <code>true</code> if the <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_channel.html">Channel</a> can be released and <code>false</code> otherwise. </dd></dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html#aac5971dc19973db85716773e4a9c2f9b">alexaClientSDK::avsCommon::sdkInterfaces::FocusManagerInterface</a>.</p>

</div>
</div>
<a id="a0dfc2a219f6541918feb41baeb074e0b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0dfc2a219f6541918feb41baeb074e0b">&#9670;&nbsp;</a></span>removeObserver()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::afml::FocusManager::removeObserver </td>
          <td>(</td>
          <td class="paramtype">const std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_observer_interface.html">avsCommon::sdkInterfaces::FocusManagerObserverInterface</a> &gt; &amp;&#160;</td>
          <td class="paramname"><em>observer</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Remove an observer from the focus manager.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">observer</td><td>The observer to remove. </td></tr>
  </table>
  </dd>
</dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html#ab184660c68bda429c6786a2f9c81fa08">alexaClientSDK::avsCommon::sdkInterfaces::FocusManagerInterface</a>.</p>

</div>
</div>
<a id="ae72baa5213e17c7efb150d62d2d27ac4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae72baa5213e17c7efb150d62d2d27ac4">&#9670;&nbsp;</a></span>stopAllActivities()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::afml::FocusManager::stopAllActivities </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">This method will request to stop all active channels. This will be performed asynchronously, and so, if at the time performing the stop, the channel is owned by another interface, this channel won't get stopped. </p>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html#a57d461dcbd6544021ee2e2024511233e">alexaClientSDK::avsCommon::sdkInterfaces::FocusManagerInterface</a>.</p>

</div>
</div>
<a id="a74d546bdcca778681aba6b9194279bc7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a74d546bdcca778681aba6b9194279bc7">&#9670;&nbsp;</a></span>stopForegroundActivity()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::afml::FocusManager::stopForegroundActivity </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">This method will request that the currently foregrounded <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_channel.html">Channel</a> activity be stopped, if there is one. This will be performed asynchronously, and so, if at the time of processing, the activity has stopped for any reason, then no stop will be performed. If something was stopped, the next highest priority active <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_channel.html">Channel</a> will be brought to the foreground. </p>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html#abf349cbdaf6c96cb19346828254aa111">alexaClientSDK::avsCommon::sdkInterfaces::FocusManagerInterface</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/workplace/avs-device-sdk/AFML/include/AFML/<a class="el" href="_focus_manager_8h_source.html">FocusManager.h</a></li>
<li>/workplace/avs-device-sdk/AFML/src/<a class="el" href="_focus_manager_8cpp.html">FocusManager.cpp</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
